<?php

namespace App\Http\Controllers;

use App\Models\HorarioDeAtencion;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class HorarioDeAtencionController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = HorarioDeAtencion::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new HorarioDeAtencion())->getFillable());
        $horarioDeAtencion = HorarioDeAtencion::create($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioDeAtencion,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(HorarioDeAtencion $horarioDeAtencion): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $horarioDeAtencion,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, HorarioDeAtencion $horarioDeAtencion): JsonResponse
    {
        $payload = $request->only((new HorarioDeAtencion())->getFillable());
        $horarioDeAtencion->update($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioDeAtencion,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(HorarioDeAtencion $horarioDeAtencion): JsonResponse
    {
        $horarioDeAtencion->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}